## mdadm 4.1

=== Makefile ===
#
# mdadm - manage Linux "md" devices aka RAID arrays.
#
# Copyright (C) 2001-2002 Neil Brown <neilb@cse.unsw.edu.au>
# Copyright (C) 2013 Neil Brown <neilb@suse.de>
#
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Author: Neil Brown
#    Email: <neilb@cse.unsw.edu.au>
#    Paper: Neil Brown
#           School of Computer Science and Engineering
#           The University of New South Wales
#           Sydney, 2052
#           Australia
#

# define "CXFLAGS" to give extra flags to CC.
# e.g.  make CXFLAGS=-O to optimise
CXFLAGS ?=-O2
TCC = tcc
UCLIBC_GCC = $(shell for nm in i386-uclibc-linux-gcc i386-uclibc-gcc; do which $$nm > /dev/null && { echo $$nm ; exit; } ; done; echo false No uclibc found )
#DIET_GCC = diet gcc
# sorry, but diet-libc doesn't know about posix_memalign,
# so we cannot use it any more.
DIET_GCC = gcc -DHAVE_STDINT_H

KLIBC=/home/src/klibc/klibc-0.77

KLIBC_GCC = gcc -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32

ifdef COVERITY
COVERITY_FLAGS=-include coverity-gcc-hack.h
endif

CC ?= $(CROSS_COMPILE)gcc
CXFLAGS ?= -ggdb
CWFLAGS = -Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter
ifdef WARN_UNUSED
CWFLAGS += -Wp,-D_FORTIFY_SOURCE=2 -O3
endif

FALLTHROUGH := $(shell gcc -v --help 2>&1 | grep "implicit-fallthrough" | wc -l)
ifneq "$(FALLTHROUGH)"  "0"
CWFLAGS += -Wimplicit-fallthrough=0
endif

ifdef DEBIAN
CPPFLAGS += -DDEBIAN
endif
ifdef DEFAULT_OLD_METADATA
 CPPFLAGS += -DDEFAULT_OLD_METADATA
 DEFAULT_METADATA=0.90
else
 DEFAULT_METADATA=1.2
endif
CPPFLAGS += -DBINDIR=\"$(BINDIR)\"

PKG_CONFIG ?= pkg-config

SYSCONFDIR = /etc
CONFFILE = $(SYSCONFDIR)/mdadm.conf
CONFFILE2 = $(SYSCONFDIR)/mdadm/mdadm.conf
MAILCMD =/usr/sbin/sendmail -t
CONFFILEFLAGS = -DCONFFILE=\"$(CONFFILE)\" -DCONFFILE2=\"$(CONFFILE2)\"
# Both MAP_DIR and MDMON_DIR should be somewhere that persists across the
# pivotroot from early boot to late boot.
# /run is best, but for distros that don't support that.
# /dev can work, in which case you probably want /dev/.mdadm
RUN_DIR=/run/mdadm
CHECK_RUN_DIR=1
MAP_DIR=$(RUN_DIR)
MAP_FILE = map
MAP_PATH = $(MAP_DIR)/$(MAP_FILE)
MDMON_DIR = $(RUN_DIR)
# place for autoreplace cookies
FAILED_SLOTS_DIR = $(RUN_DIR)/failed-slots
SYSTEMD_DIR=/lib/systemd/system
LIB_DIR=/usr/libexec/mdadm

COROSYNC:=$(shell [ -d /usr/include/corosync ] || echo -DNO_COROSYNC)
DLM:=$(shell [ -f /usr/include/libdlm.h ] || echo -DNO_DLM)

DIRFLAGS = -DMAP_DIR=\"$(MAP_DIR)\" -DMAP_FILE=\"$(MAP_FILE)\"
DIRFLAGS += -DMDMON_DIR=\"$(MDMON_DIR)\"
DIRFLAGS += -DFAILED_SLOTS_DIR=\"$(FAILED_SLOTS_DIR)\"
CFLAGS = $(CWFLAGS) $(CXFLAGS) -DSendmail=\""$(MAILCMD)"\" $(CONFFILEFLAGS) $(DIRFLAGS) $(COROSYNC) $(DLM)

VERSION = $(shell [ -d .git ] && git describe HEAD | sed 's/mdadm-//')
VERS_DATE = $(shell [ -d .git ] && date --iso-8601 --date="`git log -n1 --format=format:%cd --date=iso --date=short`")
DVERS = $(if $(VERSION),-DVERSION=\"$(VERSION)\",)
DDATE = $(if $(VERS_DATE),-DVERS_DATE="\"$(VERS_DATE)\"",)
CFLAGS += $(DVERS) $(DDATE)

# The glibc TLS ABI requires applications that call clone(2) to set up
# TLS data structures, use pthreads until mdmon implements this support
USE_PTHREADS = 1
ifdef USE_PTHREADS
CFLAGS += -DUSE_PTHREADS
MON_LDFLAGS += -pthread
endif

# If you want a static binary, you might uncomment these
# LDFLAGS = -static
# STRIP = -s
LDLIBS=-ldl

INSTALL = /usr/bin/install
DESTDIR =
BINDIR  = /sbin
MANDIR  = /usr/share/man
MAN4DIR = $(MANDIR)/man4
MAN5DIR = $(MANDIR)/man5
MAN8DIR = $(MANDIR)/man8

UDEVDIR := $(shell $(PKG_CONFIG) --variable=udevdir udev 2>/dev/null)
ifndef UDEVDIR
 UDEVDIR = /lib/udev
endif

ifeq (,$(findstring s,$(MAKEFLAGS)))
	ECHO=echo
else
	ECHO=:
endif

OBJS =  mdadm.o config.o policy.o mdstat.o  ReadMe.o util.o maps.o lib.o \
	Manage.o Assemble.o Build.o \
	Create.o Detail.o Examine.o Grow.o Monitor.o dlink.o Kill.o Query.o \
	Incremental.o Dump.o \
	mdopen.o super0.o super1.o super-ddf.o super-intel.o bitmap.o \
	super-mbr.o super-gpt.o \
	restripe.o sysfs.o sha1.o mapfile.o crc32.o sg_io.o msg.o xmalloc.o \
	platform-intel.o probe_roms.o crc32c.o

CHECK_OBJS = restripe.o sysfs.o maps.o lib.o xmalloc.o dlink.o

SRCS =  $(patsubst %.o,%.c,$(OBJS))

INCL = mdadm.h part.h bitmap.h

MON_OBJS = mdmon.o monitor.o managemon.o util.o maps.o mdstat.o sysfs.o \
	policy.o lib.o \
	Kill.o sg_io.o dlink.o ReadMe.o super-intel.o \
	super-mbr.o super-gpt.o \
	super-ddf.o sha1.o crc32.o msg.o bitmap.o xmalloc.o \
	platform-intel.o probe_roms.o crc32c.o

MON_SRCS = $(patsubst %.o,%.c,$(MON_OBJS))

STATICSRC = pwgr.c
STATICOBJS = pwgr.o

all : mdadm mdmon
man : mdadm.man md.man mdadm.conf.man mdmon.man raid6check.man

check_rundir:
	@if [ ! -d "$(dir $(RUN_DIR))" -a  "$(CHECK_RUN_DIR)" = 1 ]; then \
		echo "***** Parent of $(RUN_DIR) does not exist.  Maybe set different RUN_DIR="; \
		echo "*****  e.g. make RUN_DIR=/dev/.mdadm" ; \
		echo "***** or set CHECK_RUN_DIR=0"; exit 1; \
	fi

everything: all mdadm.static swap_super test_stripe raid6check \
	mdadm.Os mdadm.O2 man
everything-test: all mdadm.static swap_super test_stripe \
	mdadm.Os mdadm.O2 man
# mdadm.uclibc doesn't work on x86-64
# mdadm.tcc doesn't work..

%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(COVERITY_FLAGS) -o $@ -c $<

mdadm : $(OBJS) | check_rundir
	$(CC) $(CFLAGS) $(LDFLAGS) -o mdadm $(OBJS) $(LDLIBS)

mdadm.static : $(OBJS) $(STATICOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -static -o mdadm.static $(OBJS) $(STATICOBJS) $(LDLIBS)

mdadm.tcc : $(SRCS) $(INCL)
	$(TCC) -o mdadm.tcc $(SRCS)

mdadm.klibc : $(SRCS) $(INCL)
	rm -f $(OBJS)
	$(CC) -nostdinc -iwithprefix include -I$(KLIBC)/klibc/include -I$(KLIBC)/linux/include -I$(KLIBC)/klibc/arch/i386/include -I$(KLIBC)/klibc/include/bits32 $(CFLAGS) $(SRCS)

mdadm.Os : $(SRCS) $(INCL)
	$(CC) -o mdadm.Os $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -Os $(SRCS) $(LDLIBS)

mdadm.O2 : $(SRCS) $(INCL) mdmon.O2
	$(CC) -o mdadm.O2 $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(SRCS) $(LDLIBS)

mdmon.O2 : $(MON_SRCS) $(INCL) mdmon.h
	$(CC) -o mdmon.O2 $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -DHAVE_STDINT_H -O2 -D_FORTIFY_SOURCE=2 $(MON_SRCS) $(LDLIBS)

# use '-z now' to guarantee no dynamic linker interactions with the monitor thread
mdmon : $(MON_OBJS) | check_rundir
	$(CC) $(CFLAGS) $(LDFLAGS) $(MON_LDFLAGS) -Wl,-z,now -o mdmon $(MON_OBJS) $(LDLIBS)
msg.o: msg.c msg.h

test_stripe : restripe.c xmalloc.o mdadm.h
	$(CC) $(CFLAGS) $(CXFLAGS) $(LDFLAGS) -o test_stripe xmalloc.o  -DMAIN restripe.c

raid6check : raid6check.o mdadm.h $(CHECK_OBJS)
	$(CC) $(CXFLAGS) $(LDFLAGS) -o raid6check raid6check.o $(CHECK_OBJS)

mdadm.8 : mdadm.8.in
	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' \
	-e 's,{MAP_PATH},$(MAP_PATH),g'  mdadm.8.in > mdadm.8

mdadm.man : mdadm.8
	man -l mdadm.8 > mdadm.man

mdmon.man : mdmon.8
	man -l mdmon.8 > mdmon.man

md.man : md.4
	man -l md.4 > md.man

mdadm.conf.man : mdadm.conf.5
	man -l mdadm.conf.5 > mdadm.conf.man

raid6check.man : raid6check.8
	man -l raid6check.8 > raid6check.man

$(OBJS) : $(INCL) mdmon.h
$(MON_OBJS) : $(INCL) mdmon.h

sha1.o : sha1.c sha1.h md5.h
	$(CC) $(CFLAGS) -DHAVE_STDINT_H -o sha1.o -c sha1.c

install : mdadm mdmon install-man install-udev
	$(INSTALL) -D $(STRIP) -m 755 mdadm $(DESTDIR)$(BINDIR)/mdadm
	$(INSTALL) -D $(STRIP) -m 755 mdmon $(DESTDIR)$(BINDIR)/mdmon

install-static : mdadm.static install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.static $(DESTDIR)$(BINDIR)/mdadm

install-tcc : mdadm.tcc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.tcc $(DESTDIR)$(BINDIR)/mdadm

install-uclibc : mdadm.uclibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.uclibc $(DESTDIR)$(BINDIR)/mdadm

install-klibc : mdadm.klibc install-man
	$(INSTALL) -D $(STRIP) -m 755 mdadm.klibc $(DESTDIR)$(BINDIR)/mdadm

install-man: mdadm.8 md.4 mdadm.conf.5 mdmon.8
	$(INSTALL) -D -m 644 mdadm.8 $(DESTDIR)$(MAN8DIR)/mdadm.8
	$(INSTALL) -D -m 644 mdmon.8 $(DESTDIR)$(MAN8DIR)/mdmon.8
	$(INSTALL) -D -m 644 md.4 $(DESTDIR)$(MAN4DIR)/md.4
	$(INSTALL) -D -m 644 mdadm.conf.5 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5

install-udev: udev-md-raid-arrays.rules udev-md-raid-assembly.rules udev-md-raid-creating.rules \
		udev-md-clustered-confirm-device.rules 
	@for file in 01-md-raid-creating.rules 63-md-raid-arrays.rules 64-md-raid-assembly.rules \
		69-md-clustered-confirm-device.rules ; \
	do sed -e 's,BINDIR,$(BINDIR),g' udev-$${file#??-} > .install.tmp.1 && \
	   $(ECHO) $(INSTALL) -D -m 644 udev-$${file#??-} $(DESTDIR)$(UDEVDIR)/rules.d/$$file ; \
	   $(INSTALL) -D -m 644 .install.tmp.1 $(DESTDIR)$(UDEVDIR)/rules.d/$$file ; \
	   rm -f .install.tmp.1; \
	done

install-systemd: systemd/mdmon@.service
	@for file in mdmon@.service mdmonitor.service mdadm-last-resort@.timer \
		mdadm-last-resort@.service mdadm-grow-continue@.service; \
	do sed -e 's,BINDIR,$(BINDIR),g' systemd/$$file > .install.tmp.2 && \
	   $(ECHO) $(INSTALL) -D -m 644 systemd/$$file $(DESTDIR)$(SYSTEMD_DIR)/$$file ; \
	   $(INSTALL) -D -m 644 .install.tmp.2 $(DESTDIR)$(SYSTEMD_DIR)/$$file ; \
	   rm -f .install.tmp.2; \
	done
	@for file in mdadm.shutdown ; \
	do sed -e 's,BINDIR,$(BINDIR),g' systemd/$$file > .install.tmp.3 && \
	   $(ECHO) $(INSTALL) -D -m 755  systemd/$$file $(DESTDIR)$(SYSTEMD_DIR)-shutdown/$$file ; \
	   $(INSTALL) -D -m 755  .install.tmp.3 $(DESTDIR)$(SYSTEMD_DIR)-shutdown/$$file ; \
	   rm -f .install.tmp.3; \
	done
	if [ -f /etc/SuSE-release -o -n "$(SUSE)" ] ;then $(INSTALL) -D -m 755 systemd/SUSE-mdadm_env.sh $(DESTDIR)$(LIB_DIR)/mdadm_env.sh ;fi

uninstall:
	rm -f $(DESTDIR)$(MAN8DIR)/mdadm.8 $(DESTDIR)$(MAN8DIR)/mdmon.8 $(DESTDIR)$(MAN4DIR)/md.4 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5 $(DESTDIR)$(BINDIR)/mdadm

test: mdadm mdmon test_stripe swap_super raid6check
	@echo "Please run './test' as root"

clean :
	rm -f mdadm mdmon $(OBJS) $(MON_OBJS) $(STATICOBJS) core *.man \
	mdadm.tcc mdadm.uclibc mdadm.static *.orig *.porig *.rej *.alt \
	.merge_file_* mdadm.Os mdadm.O2 mdmon.O2 swap_super init.cpio.gz \
	mdadm.uclibc.static test_stripe raid6check raid6check.o mdmon mdadm.8
	rm -rf cov-int

dist : clean
	./makedist

testdist : everything-test clean
	./makedist test

TAGS :
	etags *.h *.c

DISTRO_MAKEFILE := $(wildcard distropkg/Makefile)
ifdef DISTRO_MAKEFILE
include $(DISTRO_MAKEFILE)
endif

=== debian/changelog ===
mdadm (4.1-11) unstable; urgency=medium

  * Load efivars module in initramfs, if available. (Closes: #962844)
  * Do not explicitly include /bin/rm in initramfs; /usr/bin/rm
    is already present. (See: #875918)
  * Bump Standards-Version to 4.5.1.

 -- Felix Lechner <felix.lechner@lease-up.com>  Tue, 09 Feb 2021 20:02:47 -0800

mdadm (4.1-10) unstable; urgency=medium

  * For initramfs, copy 'rm' executable from existing location; and to /bin. (Closes: #974829)

 -- Felix Lechner <felix.lechner@lease-up.com>  Sun, 15 Nov 2020 04:32:19 -0800

mdadm (4.1-9) unstable; urgency=medium

  * Add 'rm' executable to initramfs hook. (Closes: #875918)
  * Update Brazilian debconf translation. (Closes: #972835)
  * Bump d/watch file standard to version 4.

 -- Felix Lechner <felix.lechner@lease-up.com>  Sat, 14 Nov 2020 20:46:29 -0800

mdadm (4.1-8) unstable; urgency=medium

  * Comprehensive FAQ improvements and amendments.(Closes: #715387)
  * Update Finnish debconf translation. (Closes: #972143)
  * Update Portuguese debconf translation. (Closes: #971941)
  * Update Basque debconf translation.

 -- Felix Lechner <felix.lechner@lease-up.com>  Tue, 13 Oct 2020 11:15:45 -0700

mdadm (4.1-7) unstable; urgency=medium

  * Look for md device in /dev/md and exit gracefully on failure.
    (Closes: #958060, #970329)
  * Update Spanish, Italian, Slovak and Russian debconf translations.
    (Closes: #970381, #970568, #970578)

 -- Felix Lechner <felix.lechner@lease-up.com>  Mon, 21 Sep 2020 07:35:13 -0700

mdadm (4.1-6) unstable; urgency=medium

  * Install misc/mdcheck; thanks Richard Laager. (Closes: #960132)
  * Update French, Dutch and German debconf translations. (Closes: #935184,
    #940851, #956350)
  * Bring command-line help in line with manual page. (Closes: #932791)
  * Fix spelling and groff macro issues in manual pages. (Closes: #915182,
    #916946, #962946)
  * Explain 'max' keyword in command-line option --size. (Closes: #933773)
  * Patch d/README.recipes for clarity. (Closes: #619043)
  * Enable autopkgtest for installed version. Requires isolation-machine,
    untested. (Closes: #872118)
  * Adopt package. (Closes: #924367)
  * Turn on hardening.
  * Avoid a race condition in d/mdadm-shutdown.service.
  * Implement missing status option in /etc/init.d/mdadm-waitidle.
  * Add missing Documentation keys to several service files.
  * Upgrade debhelper compat to 13; use new prerequisite style.
  * Set Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.0.
  * Convert copyright to DEP-5 machine-readable format.
  * Host Vcs on salsa.d.o.
  * Adopt DEP-14 branch naming in Vcs-Git
  * Enable standard Salsa CI pipeline.
  * Fix typos in executables.
  * Explain that --name does not work in Grow mode.
  * Convert international debconf translations to UTF-8.
  * Capitalize first word in package synopsis.
  * Add Lintian overrides for tags that may not be appropriate.

 -- Felix Lechner <felix.lechner@lease-up.com>  Sat, 12 Sep 2020 20:46:58 -0700

mdadm (4.1-5) unstable; urgency=medium

  * QA upload.
  * Fix cross-compilation failure. (Closes: #866522).
    Thanks to Helmut Grohne.
  * Add support for raid0/linear 'broken' state. (Closes: #943520).
    Thanks to Guilherme G. Piccoli and Dan Streetman. LP: #1847924.

 -- dann frazier <dannf@debian.org>  Wed, 22 Jan 2020 09:56:25 -0700

mdadm (4.1-4) unstable; urgency=medium

  * QA upload.
  * Add support for RAID0 layouts. (Closes: #944676) (LP: #1850540)

 -- dann frazier <dannf@debian.org>  Mon, 02 Dec 2019 14:35:49 -0700

mdadm (4.1-3) unstable; urgency=medium

  * QA upload.
  * Adding debconf question to disable daily array scan (Closes: #689304):
    - if enabled (default), mdadm checks once a day for degraded arrays
      and missing spares to ensure that such events don't go unnoticed.
    - this is not useful when the system is part of an infrastructure
      with dedicated monitoring systems (e.g. icinga).
    - this debconf question makes it possible to disable these checks.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 09 Aug 2019 17:19:20 +0000

mdadm (4.1-2) unstable; urgency=medium

  * QA upload.
  * Orphan package.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 12 Mar 2019 03:58:03 +0000

mdadm (4.1-1) unstable; urgency=medium

  * New upstream release.
  * Cherrypick patches from master to 757e55435997e355ee9b03e5d913b5496a3c39a8.
  * Drop XC- prefix from Package-Type field in debian/control.
  * Bump standards version to 4.3.0.
  * Use https in the watch file.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 15 Jan 2019 18:23:53 +0000

=== debian/control ===
Source: mdadm
Section: admin
Priority: optional
Maintainer: Felix Lechner <felix.lechner@lease-up.com>
Build-Depends:
 debhelper-compat (= 13),
 groff-base,
 po-debconf
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/lechner/mdadm.git -b debian/master
Vcs-Browser: https://salsa.debian.org/lechner/mdadm
Homepage: http://neil.brown.name/blog/mdadm

Package: mdadm
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 debconf,
 lsb-base,
 udev
Recommends:
 ${mta:Recommends},
 kmod | module-init-tools
Suggests:
 ${mta:Suggests},
 dracut-core
Description: Tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This package automatically configures mdadm to assemble arrays during the
 system startup process. If not needed, this functionality can be disabled.

Package: mdadm-udeb
Section: debian-installer
Package-Type: udeb
Architecture: linux-any
Depends:
 ${shlibs:Depends}
Description: Tool to administer Linux MD arrays (software RAID)
 The mdadm utility can be used to create, manage, and monitor MD
 (multi-disk) arrays for software RAID or multipath I/O.
 .
 This is a minimal package used by the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

export CROSS_COMPILE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)-
LDFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get LDFLAGS)
CXFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CFLAGS) \
	  $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CPPFLAGS)
BUILDFLAGS = CXFLAGS="$(CXFLAGS)" LDFLAGS="$(LDFLAGS)" DEBIAN=yes
DESTDIR = $(CURDIR)/debian/mdadm
DESTDIR_UDEB = $(DESTDIR)-udeb

build-arch: build-stamp

build-stamp:
	dh_testdir
	$(MAKE) all $(BUILDFLAGS) CONFFILE=/etc/mdadm/mdadm.conf CONFFILE2=/etc/mdadm.conf
	touch $@

# udeb rules should go, the only diff is the conffile location,
# and d-i specifies path explicitly when needed

udeb/dir-stamp:
	rm -rf udeb
	mkdir udeb
	ln *.[ch] Makefile udeb/
	touch $@

build-arch: udeb/build-stamp

udeb/build-stamp: udeb/dir-stamp
	dh_testdir
	$(MAKE) -C udeb mdadm mdmon $(BUILDFLAGS) CONFFILE=/tmp/mdadm.conf
	touch $@

clean:
	dh_testdir
	rm -f build-stamp
	$(MAKE) clean
	rm -rf udeb
	dh_clean

install-arch: build-arch
	dh_testdir
	dh_prep
	dh_installdirs

	$(MAKE) install install-systemd DESTDIR=$(DESTDIR)

	mkdir -p $(DESTDIR)/etc/mdadm
	install -Dm0755 debian/initramfs/hook \
		$(DESTDIR)/usr/share/initramfs-tools/hooks/mdadm
	install -Dm0755 debian/initramfs/script.local-block \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-block/mdadm
	install -Dm0755 debian/initramfs/script.local-bottom \
		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-bottom/mdadm
	install -Dm0644 debian/mdadm.modules \
		$(DESTDIR)/etc/modprobe.d/mdadm.conf

	install -Dm0755 debian/mkconf $(DESTDIR)/usr/share/mdadm/mkconf
	install -Dm0755 debian/checkarray $(DESTDIR)/usr/share/mdadm/checkarray
	install -Dm0755 debian/bugscript $(DESTDIR)/usr/share/bug/mdadm/script
	install -Dm0755 misc/mdcheck $(DESTDIR)/usr/share/mdadm/mdcheck
	install -Dm0755 udeb/mdadm $(DESTDIR_UDEB)/sbin/mdadm
	install -Dm0755 udeb/mdmon $(DESTDIR_UDEB)/sbin/mdmon
	install -Dm0644 $(DESTDIR)/lib/udev/rules.d/63-md-raid-arrays.rules $(DESTDIR_UDEB)/lib/udev/rules.d/63-md-raid-arrays.rules
	install -Dm0644 debian/mdadm-shutdown.service $(DESTDIR)/lib/systemd/system/mdadm-shutdown.service
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
	install -Dm0644 $(DESTDIR)/lib/udev/rules.d/64-md-raid-assembly.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid-assembly.rules
	install -Dm0644 debian/source_mdadm.py $(DESTDIR)/usr/share/apport/package-hooks/source_mdadm.py
endif

binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs
	dh_installexamples -pmdadm mdadm.conf-example misc/syslog-events
	dh_installinit --init-script=mdadm-waitidle --no-start -- stop 98 0 6 .
	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm-waitidle.service
	dh_installinit -- defaults 25
	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm.service
	dh_installman
	dh_installcron
	dh_installchangelogs ChangeLog
	dh_installlogcheck
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
	dh_gencontrol -- -Vmta:Suggests="default-mta | mail-transport-agent"
else
	dh_gencontrol -- -Vmta:Recommends="default-mta | mail-transport-agent"
endif
	dh_lintian
	dh_md5sums
	dh_builddeb

build: build-arch
install: install-arch
binary: binary-arch
build-indep:
install-indep:
binary-indep:
.PHONY: clean build build-indep build-arch binary binary-indep binary-arch install install-indep install-arch

=== debian/watch ===
version=4
https://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-([.[:digit:]]+).tar.gz

## mdadm 4.2~rc2

=== debian/changelog ===
mdadm (4.2~rc2-7) unstable; urgency=medium

  * In initramfs, load efivarfs module, which has a new name. (Closes: #995047)

 -- Felix Lechner <felix.lechner@lease-up.com>  Sat, 25 Sep 2021 21:57:51 -0700

mdadm (4.2~rc2-6) unstable; urgency=medium

  * Pass proper build flags to make.

 -- Felix Lechner <felix.lechner@lease-up.com>  Thu, 26 Aug 2021 06:57:18 -0700

mdadm (4.2~rc2-5) unstable; urgency=medium

  * Use dh sequencer.

 -- Felix Lechner <felix.lechner@lease-up.com>  Wed, 25 Aug 2021 12:01:24 -0700

mdadm (4.2~rc2-4) unstable; urgency=medium

  * Generate config even when SOURCE_DATE_EPOCH is not set; fixup to 04adb527.
   (Closes: #992853)

 -- Felix Lechner <felix.lechner@lease-up.com>  Tue, 24 Aug 2021 07:01:33 -0700

mdadm (4.2~rc2-3) unstable; urgency=medium

  * Add support for 'repair' action to checkarray. (Closes: #772465)
  * Use a reproducible timestamp in mkconf; delete temporary file in initramfs.
   (Closes: #982607)
  * Adjust character set of Swedish debconf translation; no string changes.
    (Closes: #972357)
  * Update the Czech translations of debconf messages. (Closes: #972440)
  * Drop version check in postinst for an upload predating the release of oldstable.
  * Add a file with upstream metadata providing the information sought by DEP-12.
  * Fix typo in manual page.
  * Refresh Debian patches.

 -- Felix Lechner <felix.lechner@lease-up.com>  Mon, 23 Aug 2021 13:01:29 -0700

mdadm (4.2~rc2-2) unstable; urgency=medium

  * Upload targeting unstable.
  * Fix uscan regex for upstream tarballs.

 -- Felix Lechner <felix.lechner@lease-up.com>  Sun, 15 Aug 2021 14:56:17 -0700

mdadm (4.2~rc2-1) experimental; urgency=medium

  * New release candidate from upstream.

 -- Felix Lechner <felix.lechner@lease-up.com>  Tue, 03 Aug 2021 07:36:19 -0700

mdadm (4.2~rc1-1) experimental; urgency=medium

  * New release candidate from upstream.
  * Add libudev-dev to Build-Depends.
  * Drop patches previously cherry-picked from upstream:
    - 0001-Assemble-keep-MD_DISK_FAILFAST-and-MD_DISK_WRITEMOST.patch
      (now 0833f9c3)
    - 0002-Document-PART-POLICY-lines.patch (now 6b611284)
    - 0003-policy-support-devices-with-multiple-paths.patch (now cd72f9d1)
    - 0004-mdcheck-add-systemd-unit-files-to-run-mdcheck.patch (now 4199d3c6)
    - 0005-Monitor-add-system-timer-to-run-oneshot-periodically.patch
      (now 7cd7e91a)
    - 0006-imsm-update-metadata-correctly-while-raid10-double-d.patch
      (now d7a1fda2)
    - 0007-Assemble-mask-FAILFAST-and-WRITEMOSTLY-flags-when-fi.patch
      (now 563ac108)
    - 0008-Grow-avoid-overflow-in-compute_backup_blocks.patch
      (now 085df422)
    - 0009-Grow-report-correct-new-chunk-size.patch (now 76d505de)
    - 0010-policy.c-prevent-NULL-pointer-referencing.patch (now 467e6a1b)
    - 0011-policy.c-Fix-for-compiler-error.patch (now 757e55435)
    - 0001-Create-add-support-for-RAID0-layouts.patch (now 329dfc28)
    - 0002-Assemble-add-support-for-RAID0-layouts.patch (now 027c099f)
    - 0001-Respect-CROSS_COMPILE-when-CC-is-the-default.patch (now aced6fc9)
  * Drop patches accepted upstream:
    - typos-in-programs.patch (now ebf3be99)
    - lp-1847924-introduce-new-array-state-broken.patch (now 43ebc910)
  * Refresh remaining patches.
  * Adapt d/watch to accept release candidates.

 -- Felix Lechner <felix.lechner@lease-up.com>  Mon, 26 Jul 2021 20:34:36 -0700

## mdadm 4.2~rc2.1

=== debian/changelog ===
mdadm (4.2~rc2.1-1+dde) UNRELEASED; urgency=medium

  * update

 -- Felix Lechner <felix.lechner@lease-up.com>  Wed, 27 Jul 2022 09:03:54 +0800

mdadm (4.2~rc2.1-1+dde) unstable; urgency=medium

  * Add sunway support.

 -- Miao Changwei <miaochangwei@uniontech.com>  Fri, 06 May 2022 15:52:35 +0800

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Felix Lechner <felix.lechner@lease-up.com>
 Build-Depends:
  debhelper-compat (= 13),
+ libudev-dev,
  groff-base,
  po-debconf
 Standards-Version: 4.5.1

## mdadm 4.2

=== debian/changelog ===
mdadm (4.2-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1959843)

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 24 Feb 2022 15:19:00 +0000

mdadm (4.2~rc2-2ubuntu1) impish; urgency=medium

  * Merge from Debian unstable (LP: #1940096), remaining changes:
    - Ship finalrd hook.
    - Do not install mdadm-shutdown.service on Ubuntu.
    - Drop broken and unused init scripts in favor of native systemd units,
      which can cause failure to reconfigure mdadm package under certain
      confiment types.
    - Drop /etc/cron.d/mdadm and migrate to systemd mdcheck_start|continue
      timer units.
    - Drop /etc/cron.daily/mdadm and migrate to system mdmonitor-oneshot
      timer unit.
    - mdcheck_start.timer configures the mdcheck on a first sunday of the
      month, with a randomized start delay of up to 24h, and runs for at
      most 6h. mdcheck_continue.timer kicks off daily, with a randomized
      start delay of up to 12h, and continues mdcheck for at most 6h.
    - mdmonitor-oneshot.timer runs daily, with a randomized start delay of
      up to 24h.
    - One can use systemd drop-ins to change .timer units timings, set
      environmental variables to decrease/increase the length of checking,
      or start the checks by hand. Previously used checkarray is still
      available, albeit not used by timer units.
    - Above ensures that previous daily / monthly checks are performed, but
      are randomized, such that performance is not as impacted across a
      cluster of machines.
    - Honor the debconf daily autoscan setting in the systemd timer.
    - d/p/mdcheck-fix-empty-spaces-in-timer-unit-files.patch:
      - The spaces were causing a FTBFS situation, triggered by
        dh_installsystemd not finding units.
    - Mention mdmonitor-oneshot.service instead of /etc/cron.daily/mdadm
      in /etc/default/mdadm

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 17 Aug 2021 17:41:27 +0000

mdadm (4.2~rc1-1ubuntu1) impish; urgency=medium

  * Merge from Debian experimental (LP: #1935895), remaining changes:
    - Ship finalrd hook.
    - Do not install mdadm-shutdown.service on Ubuntu.
    - Drop broken and unused init scripts in favor of native systemd units,
      which can cause failure to reconfigure mdadm package under certain
      confiment types.
    - Drop /etc/cron.d/mdadm and migrate to systemd mdcheck_start|continue
      timer units.
    - Drop /etc/cron.daily/mdadm and migrate to system mdmonitor-oneshot
      timer unit.
    - mdcheck_start.timer configures the mdcheck on a first sunday of the
      month, with a randomized start delay of up to 24h, and runs for at
      most 6h. mdcheck_continue.timer kicks off daily, with a randomized
      start delay of up to 12h, and continues mdcheck for at most 6h.
    - mdmonitor-oneshot.timer runs daily, with a randomized start delay of
      up to 24h.
    - One can use systemd drop-ins to change .timer units timings, set
      environmental variables to decrease/increase the length of checking,
      or start the checks by hand. Previously used checkarray is still
      available, albeit not used by timer units.
    - Above ensures that previous daily / monthly checks are performed, but
      are randomized, such that performance is not as impacted across a
      cluster of machines.
    - Honor the debconf daily autoscan setting in the systemd timer.
    - d/p/mdcheck-fix-empty-spaces-in-timer-unit-files.patch:
      - The spaces were causing a FTBFS situation, triggered by
        dh_installsystemd not finding units.
    - Mention mdmonitor-oneshot.service instead of /etc/cron.daily/mdadm
      in /etc/default/mdadm
  * Dropped changes:
    - d/p/mdcheck-when-mdcheck-start-is-enabled-mdcheck-continue-too.patch:
      - When mdcheck_start is enabled, enable mdcheck_continue too.
    - d/p/mdcheck-log-when-done.patch:
      - Make sure mdcheck logs the completion too, so that
      it can be determined how long the raid check took.
    - Cherrypick upstream fix to allow assembling dirty degrated IMSM raid
      arrays with --force flag

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 28 Jul 2021 10:38:46 +0000

mdadm (4.1-11ubuntu1) impish; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Ship finalrd hook.
    - Do not install mdadm-shutdown.service on Ubuntu.
    - Drop broken and unused init scripts in favor of native systemd units,
      which can cause failure to reconfigure mdadm package under certain
      confiment types.
    - Drop /etc/cron.d/mdadm and migrate to systemd mdcheck_start|continue
      timer units.
    - Drop /etc/cron.daily/mdadm and migrate to system mdmonitor-oneshot
      timer unit.
    - mdcheck_start.timer configures the mdcheck on a first sunday of the
      month, with a randomized start delay of up to 24h, and runs for at
      most 6h. mdcheck_continue.timer kicks off daily, with a randomized
      start delay of up to 12h, and continues mdcheck for at most 6h.
    - mdmonitor-oneshot.timer runs daily, with a randomized start delay of
      up to 24h.
    - One can use systemd drop-ins to change .timer units timings, set
      environmental variables to decrease/increase the length of checking,
      or start the checks by hand. Previously used checkarray is still
      available, albeit not used by timer units.
    - Above ensures that previous daily / monthly checks are performed, but
      are randomized, such that performance is not as impacted across a
      cluster of machines.
    - Honor the debconf daily autoscan setting in the systemd timer.
    - d/p/mdcheck-fix-empty-spaces-in-timer-unit-files.patch:
      - The spaces were causing a FTBFS situation, triggered by
        dh_installsystemd not finding units.
    - d/p/mdcheck-when-mdcheck-start-is-enabled-mdcheck-continue-too.patch:
      - When mdcheck_start is enabled, enable mdcheck_continue too.
    - d/p/mdcheck-log-when-done.patch:


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mdadm
 Section: admin
 Priority: optional
-Maintainer: Felix Lechner <felix.lechner@lease-up.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Felix Lechner <felix.lechner@lease-up.com>
 Build-Depends:
  debhelper-compat (= 13),
  libudev-dev,
@@ -25,6 +26,7 @@
  udev
 Recommends:
  ${mta:Recommends},
+ finalrd (>= 3~),
  kmod | module-init-tools
 Suggests:
  ${mta:Suggests},

=== debian/rules ===
--- 
+++ 
@@ -60,6 +60,8 @@
 		$(DESTDIR)/usr/share/initramfs-tools/scripts/local-bottom/mdadm
 	install -Dm0644 debian/mdadm.modules \
 		$(DESTDIR)/etc/modprobe.d/mdadm.conf
+	install -Dm0755 debian/mdadm.finalrd \
+		$(DESTDIR)/usr/share/finalrd/mdadm.finalrd
 
 	install -Dm0755 debian/mkconf $(DESTDIR)/usr/share/mdadm/mkconf
 	install -Dm0755 debian/checkarray $(DESTDIR)/usr/share/mdadm/checkarray
@@ -68,10 +70,11 @@
 	install -Dm0755 udeb/mdadm $(DESTDIR_UDEB)/sbin/mdadm
 	install -Dm0755 udeb/mdmon $(DESTDIR_UDEB)/sbin/mdmon
 	install -Dm0644 $(DESTDIR)/lib/udev/rules.d/63-md-raid-arrays.rules $(DESTDIR_UDEB)/lib/udev/rules.d/63-md-raid-arrays.rules
-	install -Dm0644 debian/mdadm-shutdown.service $(DESTDIR)/lib/systemd/system/mdadm-shutdown.service
 ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes), yes)
 	install -Dm0644 $(DESTDIR)/lib/udev/rules.d/64-md-raid-assembly.rules $(DESTDIR_UDEB)/lib/udev/rules.d/64-md-raid-assembly.rules
 	install -Dm0644 debian/source_mdadm.py $(DESTDIR)/usr/share/apport/package-hooks/source_mdadm.py
+else
+	install -Dm0644 debian/mdadm-shutdown.service $(DESTDIR)/lib/systemd/system/mdadm-shutdown.service
 endif
 
 binary-arch: install-arch
@@ -80,12 +83,9 @@
 	dh_installdebconf
 	dh_installdocs
 	dh_installexamples -pmdadm mdadm.conf-example misc/syslog-events
-	dh_installinit --init-script=mdadm-waitidle --no-start -- stop 98 0 6 .
-	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm-waitidle.service
-	dh_installinit -- defaults 25
-	dh_link -pmdadm /dev/null /lib/systemd/system/mdadm.service
 	dh_installman
 	dh_installcron
+	dh_installsystemd -pmdadm mdcheck_continue.timer mdcheck_start.timer mdmonitor-oneshot.timer
 	dh_installchangelogs ChangeLog
 	dh_installlogcheck
 	dh_link

=== debian/tests/control ===
Tests: test-installed
Restrictions: needs-root, isolation-machine
Depends:
 fdisk | util-linux (<< 2.29.2-3~),
 mdadm,
 udev

## mdadm 4.2+20230508

=== Makefile ===
--- 
+++ 
@@ -46,7 +46,9 @@
 COVERITY_FLAGS=-include coverity-gcc-hack.h
 endif
 
-CC ?= $(CROSS_COMPILE)gcc
+ifeq ($(origin CC),default)
+CC := $(CROSS_COMPILE)gcc
+endif
 CXFLAGS ?= -ggdb
 CWFLAGS = -Wall -Werror -Wstrict-prototypes -Wextra -Wno-unused-parameter
 ifdef WARN_UNUSED
@@ -103,7 +105,8 @@
 VERS_DATE = $(shell [ -d .git ] && date --iso-8601 --date="`git log -n1 --format=format:%cd --date=iso --date=short`")
 DVERS = $(if $(VERSION),-DVERSION=\"$(VERSION)\",)
 DDATE = $(if $(VERS_DATE),-DVERS_DATE="\"$(VERS_DATE)\"",)
-CFLAGS += $(DVERS) $(DDATE)
+DEXTRAVERSION = $(if $(EXTRAVERSION),-DEXTRAVERSION="\" - $(EXTRAVERSION)\"",)
+CFLAGS += $(DVERS) $(DDATE) $(DEXTRAVERSION)
 
 # The glibc TLS ABI requires applications that call clone(2) to set up
 # TLS data structures, use pthreads until mdmon implements this support
@@ -116,7 +119,12 @@
 # If you want a static binary, you might uncomment these
 # LDFLAGS = -static
 # STRIP = -s
-LDLIBS=-ldl
+LDLIBS = -ldl
+
+# To explicitly disable libudev, set -DNO_LIBUDEV in CXFLAGS
+ifeq (, $(findstring -DNO_LIBUDEV,  $(CXFLAGS)))
+	LDLIBS += -ludev
+endif
 
 INSTALL = /usr/bin/install
 DESTDIR =
@@ -137,7 +145,7 @@
 	ECHO=:
 endif
 
-OBJS =  mdadm.o config.o policy.o mdstat.o  ReadMe.o util.o maps.o lib.o \
+OBJS =  mdadm.o config.o policy.o mdstat.o  ReadMe.o uuid.o util.o maps.o lib.o \
 	Manage.o Assemble.o Build.o \
 	Create.o Detail.o Examine.o Grow.o Monitor.o dlink.o Kill.o Query.o \
 	Incremental.o Dump.o \
@@ -146,13 +154,13 @@
 	restripe.o sysfs.o sha1.o mapfile.o crc32.o sg_io.o msg.o xmalloc.o \
 	platform-intel.o probe_roms.o crc32c.o
 
-CHECK_OBJS = restripe.o sysfs.o maps.o lib.o xmalloc.o dlink.o
+CHECK_OBJS = restripe.o uuid.o sysfs.o maps.o lib.o xmalloc.o dlink.o
 
 SRCS =  $(patsubst %.o,%.c,$(OBJS))
 
 INCL = mdadm.h part.h bitmap.h
 
-MON_OBJS = mdmon.o monitor.o managemon.o util.o maps.o mdstat.o sysfs.o \
+MON_OBJS = mdmon.o monitor.o managemon.o uuid.o util.o maps.o mdstat.o sysfs.o config.o mapfile.o mdopen.o\
 	policy.o lib.o \
 	Kill.o sg_io.o dlink.o ReadMe.o super-intel.o \
 	super-mbr.o super-gpt.o \
@@ -174,9 +182,9 @@
 		echo "***** or set CHECK_RUN_DIR=0"; exit 1; \
 	fi
 
-everything: all mdadm.static swap_super test_stripe raid6check \
+everything: all swap_super test_stripe raid6check \
 	mdadm.Os mdadm.O2 man
-everything-test: all mdadm.static swap_super test_stripe \
+everything-test: all swap_super test_stripe \
 	mdadm.Os mdadm.O2 man
 # mdadm.uclibc doesn't work on x86-64
 # mdadm.tcc doesn't work..
@@ -219,7 +227,12 @@
 
 mdadm.8 : mdadm.8.in
 	sed -e 's/{DEFAULT_METADATA}/$(DEFAULT_METADATA)/g' \
-	-e 's,{MAP_PATH},$(MAP_PATH),g'  mdadm.8.in > mdadm.8
+	-e 's,{MAP_PATH},$(MAP_PATH),g' -e 's,{CONFFILE},$(CONFFILE),g' \
+	-e 's,{CONFFILE2},$(CONFFILE2),g'  mdadm.8.in > mdadm.8
+
+mdadm.conf.5 : mdadm.conf.5.in
+	sed -e 's,{CONFFILE},$(CONFFILE),g' \
+	-e 's,{CONFFILE2},$(CONFFILE2),g'  mdadm.conf.5.in > mdadm.conf.5
 
 mdadm.man : mdadm.8
 	man -l mdadm.8 > mdadm.man
@@ -242,9 +255,7 @@
 sha1.o : sha1.c sha1.h md5.h
 	$(CC) $(CFLAGS) -DHAVE_STDINT_H -o sha1.o -c sha1.c
 
-install : mdadm mdmon install-man install-udev
-	$(INSTALL) -D $(STRIP) -m 755 mdadm $(DESTDIR)$(BINDIR)/mdadm
-	$(INSTALL) -D $(STRIP) -m 755 mdmon $(DESTDIR)$(BINDIR)/mdmon
+install : install-bin install-man install-udev
 
 install-static : mdadm.static install-man
 	$(INSTALL) -D $(STRIP) -m 755 mdadm.static $(DESTDIR)$(BINDIR)/mdadm
@@ -276,7 +287,11 @@
 
 install-systemd: systemd/mdmon@.service
 	@for file in mdmon@.service mdmonitor.service mdadm-last-resort@.timer \
-		mdadm-last-resort@.service mdadm-grow-continue@.service; \
+		mdadm-last-resort@.service mdadm-grow-continue@.service \
+		mdcheck_start.timer mdcheck_start.service \
+		mdcheck_continue.timer mdcheck_continue.service \
+		mdmonitor-oneshot.timer mdmonitor-oneshot.service \
+		; \
 	do sed -e 's,BINDIR,$(BINDIR),g' systemd/$$file > .install.tmp.2 && \
 	   $(ECHO) $(INSTALL) -D -m 644 systemd/$$file $(DESTDIR)$(SYSTEMD_DIR)/$$file ; \
 	   $(INSTALL) -D -m 644 .install.tmp.2 $(DESTDIR)$(SYSTEMD_DIR)/$$file ; \
@@ -290,6 +305,10 @@
 	done
 	if [ -f /etc/SuSE-release -o -n "$(SUSE)" ] ;then $(INSTALL) -D -m 755 systemd/SUSE-mdadm_env.sh $(DESTDIR)$(LIB_DIR)/mdadm_env.sh ;fi
 
+install-bin: mdadm mdmon
+	$(INSTALL) -D $(STRIP) -m 755 mdadm $(DESTDIR)$(BINDIR)/mdadm
+	$(INSTALL) -D $(STRIP) -m 755 mdmon $(DESTDIR)$(BINDIR)/mdmon
+
 uninstall:
 	rm -f $(DESTDIR)$(MAN8DIR)/mdadm.8 $(DESTDIR)$(MAN8DIR)/mdmon.8 $(DESTDIR)$(MAN4DIR)/md.4 $(DESTDIR)$(MAN5DIR)/mdadm.conf.5 $(DESTDIR)$(BINDIR)/mdadm

=== debian/changelog ===
mdadm (4.2+20230508-6ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - d/control, d/mdadm.install, d/local/finalrd/mdadm.finalrd:
      Ship finalrd hook
    - d/local/initramfs-tools/init-top/00_mount_efivarfs:
      Mount efivarfs during initramfs boot phase
  * d/mdadm.maintscript: Keep Ubuntu prior-versions until after
    the release of 24.04
  * Dropped changes, included in Debian:
    - Do not install mdadm-shutdown.service on Ubuntu.
    - Drop broken and unused init scripts in favor of native systemd units,
      which can cause failure to reconfigure mdadm package under certain
      confiment types.
    - Drop /etc/cron.d/mdadm and migrate to systemd mdcheck_start|continue
      timer units.
    - Drop /etc/cron.daily/mdadm and migrate to system mdmonitor-oneshot
      timer unit.
    - mdcheck_start.timer configures the mdcheck on a first sunday of the
      month, with a randomized start delay of up to 24h, and runs for at
      most 6h. mdcheck_continue.timer kicks off daily, with a randomized
      start delay of up to 12h, and continues mdcheck for at most 6h.
    - mdmonitor-oneshot.timer runs daily, with a randomized start delay of
      up to 24h.
    - One can use systemd drop-ins to change .timer units timings, set
      environmental variables to decrease/increase the length of checking,
      or start the checks by hand. Previously used checkarray is still
      available, albeit not used by timer units.
    - Above ensures that previous daily / monthly checks are performed, but
      are randomized, such that performance is not as impacted across a
      cluster of machines.
    - Honor the debconf daily autoscan setting in the systemd timer.
    - d/p/mdcheck-fix-empty-spaces-in-timer-unit-files.patch:
      - The spaces were causing a FTBFS situation, triggered by
        dh_installsystemd not finding units.
    - Mention mdmonitor-oneshot.service instead of /etc/cron.daily/mdadm
      in /etc/default/mdadm

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 11 Aug 2023 09:59:44 +0000

mdadm (4.2+20230508-6) sid; urgency=medium

  * Uploading to sid.
  * Adding updated Dutch debconf translations from Frans Spiesschaert
    <Frans.Spiesschaert@yucom.be> (Closes: #1041873).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 24 Jul 2023 20:44:54 +0200

mdadm (4.2+20230508-5) sid; urgency=medium

  * Uploading to sid.
  * Updating package descriptions.
  * Adding updated Romanian debconf translations from Remus-Gabriel Chelu
    <remusgabriel.chelu@disroot.org> (Closes: #1039620).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 30 Jun 2023 10:07:14 +0200

mdadm (4.2+20230508-4) sid; urgency=medium

  * Uploading to sid.
  * Updating watch file.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 25 Jun 2023 16:26:53 +0200

mdadm (4.2+20230508-3) experimental; urgency=medium

  * Uploading to experimental.
  * Updating regex in logcheck ignore patterns for kernels md tunining
    message (LP: #1176560).
  * Adding debconf note when run on non-systemd systems (Closes:
    #1037496).
  * Updating debconf po files.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 24 Jun 2023 07:03:53 +0200

mdadm (4.2+20230508-2) sid; urgency=medium

  * Uploading to sid.
  * Uploading without changes after bookworm release.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 11 Jun 2023 14:32:19 +0200

mdadm (4.2+20230508-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 4.2+20230508.
  * Refreshing and updating readlink-path.patch to cover basename too.
  * Refreshing randomize-timers.patch.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 12 May 2023 14:48:12 +0200

mdadm (4.2+20230313-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 4.2+20230313.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 13 Mar 2023 17:55:55 +0100

mdadm (4.2+20230304-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 4.2+20230304.
  * Adding initial Romanian debconf translations from Remus-Gabriel Chelu
    <remusgabriel.chelu@disroot.org> (Closes: #1032713).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 13 Mar 2023 14:58:14 +0100

mdadm (4.2+20230302-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 4.2+20230302.
  * Updating host-name-in-default-mailfrom.patch for new upstream.
  * Updating exit-gracefully-when-md-device-not-found.patch for new
    upstream.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 06 Mar 2023 04:25:46 +0100

mdadm (4.2+20230227-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 4.2+20230227.
  * Removing sysvinit scripts in favour of systemd units:
    - properly checkrestart mdmonitor (Closes: #815834).
    - no update-rc.d warnings anymore (Closes: #822354).
    - properly shutdown (Closes: #829621).
    - making /etc/default/mdadm obsolete for most things (Closes: #850180).
  * Removing cron jobs in favour of systemd timers:
    - daily checks also work if system is not always on (Closes: #889978).
  * Adding rediffed patch from ubuntu to randomize md array check timers.
  * Adding rediffed patch from ubuntu to honor debconf daily scan in
    systemd unit.
  * Adding rediffed patch from ubuntu to fix empty spaces in timer unit
    files.
  * Wrap and sorting debian directory.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 28 Feb 2023 20:48:50 +0100

mdadm (4.2+20230223-2) experimental; urgency=medium

  * Uploading to experimental.
  * Updating upstream contact in copyright.
  * Silencing mounting efivars in initramfs-hook by only mounting if not
    done already.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 25 Feb 2023 22:34:46 +0100

mdadm (4.2+20230223-1) experimental; urgency=medium



=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2001-2005 Mario Jou/3en <joussen@debian.org>
# Copyright © 2005-2008 Martin F. Krafft <madduck@debian.org>
# Copyright © 2021 Felix Lechner <felix.lechner@lease-up.com>
# Distributable under the terms of the GNU GPL version 2.
#

#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

export CROSS_COMPILE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)-
export LDFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get LDFLAGS)
export CXFLAGS = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CFLAGS) \
	  $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all dpkg-buildflags --get CPPFLAGS)

export DEBIAN="yes"
export EXTRAVERSION=$(DEB_VENDOR) $(DEB_VERSION)

# these are reversed in the Makefile
export CONFFILE="/etc/mdadm/mdadm.conf"
export CONFFILE2="/etc/mdadm.conf"

%:
	dh $@

override_dh_install:
	$(MAKE) install-systemd DESTDIR=$(CURDIR)/debian/tmp
	dh_install

	mkdir -p $(CURDIR)/debian/mdadm/etc/mdadm
	chmod +x $(CURDIR)/debian/mdadm/usr/share/mdadm/mdcheck

override_dh_installsystemd:
	dh_installsystemd -pmdadm mdcheck_continue.timer mdcheck_start.timer mdmonitor-oneshot.timer

## mdadm 4.2+20231121

=== debian/changelog ===
mdadm (4.2+20231121-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control, d/mdadm.install, d/local/finalrd/mdadm.finalrd:
      Ship finalrd hook
    - d/local/initramfs-tools/init-top/00_mount_efivarfs:
      Mount efivarfs during initramfs boot phase
    - d/mdadm.maintscript: Keep Ubuntu prior-versions until after
      the release of 24.04

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 03 Jan 2024 10:15:09 +0000

mdadm (4.2+20231121-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 4.2+20231121.
  * Harmonizing license blurbs in copyright file.
  * Adding updated German debconf translations from Helge Kreutzmann
    <debian@helgefjell.de> (Closes: #1055789).
  * Adding updated Swedish debconf translations from Martin Bagge
    <brother@persilja.net> (Closes: #1057772).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 10 Dec 2023 11:57:19 +0100

mdadm (4.2+20231026-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control, d/mdadm.install, d/local/finalrd/mdadm.finalrd:
      Ship finalrd hook
    - d/local/initramfs-tools/init-top/00_mount_efivarfs:
      Mount efivarfs during initramfs boot phase
    - d/mdadm.maintscript: Keep Ubuntu prior-versions until after
      the release of 24.04

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 30 Nov 2023 13:18:00 +0000

mdadm (4.2+20231026-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 4.2+20231026.
  * Refreshing fix-manpages.patch.
  * Refreshing no-Werror.patch.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Wed, 01 Nov 2023 05:09:47 +0100

mdadm (4.2+20230508-7ubuntu1) mantic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/control, d/mdadm.install, d/local/finalrd/mdadm.finalrd:
      Ship finalrd hook
    - d/local/initramfs-tools/init-top/00_mount_efivarfs:
      Mount efivarfs during initramfs boot phase
    - d/mdadm.maintscript: Keep Ubuntu prior-versions until after
      the release of 24.04

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 05 Oct 2023 18:00:34 +0000

mdadm (4.2+20230508-7) sid; urgency=medium

  * Uploading to sid.
  * Removing generated files to fix FTBFS when build twice in a row
    (Closes: #1047538).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 14 Aug 2023 11:51:05 +0200
